/* MainWindow.c generated by valac 0.48.13, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/*
 * Copyright 2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Marius Meisenzahl <mariusmeisenzahl@gmail.com>
 *
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
typedef struct _MainWindowPrivate MainWindowPrivate;
enum  {
	MAIN_WINDOW_0_PROPERTY,
	MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* main_window_properties[MAIN_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MainWindow {
	GtkApplicationWindow parent_instance;
	MainWindowPrivate * priv;
};

struct _MainWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _MainWindowPrivate {
	GtkEntry* title_entry;
	GtkEntry* body_entry;
	GtkEntry* id_entry;
	GtkComboBoxText* priority_combobox;
};

static gint MainWindow_private_offset;
static gpointer main_window_parent_class = NULL;

GType main_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
MainWindow* main_window_new (GtkApplication* application);
MainWindow* main_window_construct (GType object_type,
                                   GtkApplication* application);
static void main_window_send_notification (MainWindow* self);
static GObject * main_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _main_window_send_notification_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void main_window_finalize (GObject * obj);
static GType main_window_get_type_once (void);

static inline gpointer
main_window_get_instance_private (MainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MainWindow_private_offset);
}

MainWindow*
main_window_construct (GType object_type,
                       GtkApplication* application)
{
	MainWindow * self = NULL;
	g_return_val_if_fail (application != NULL, NULL);
	self = (MainWindow*) g_object_new (object_type, "application", application, NULL);
	return self;
}

MainWindow*
main_window_new (GtkApplication* application)
{
	return main_window_construct (TYPE_MAIN_WINDOW, application);
}

static void
main_window_send_notification (MainWindow* self)
{
	GNotificationPriority priority = 0;
	GtkComboBoxText* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GNotification* notification = NULL;
	GtkEntry* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GNotification* _tmp6_;
	GNotification* _tmp7_;
	GtkEntry* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GNotification* _tmp11_;
	GNotificationPriority _tmp12_;
	const gchar* _tmp13_ = NULL;
	GtkEntry* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gchar* id = NULL;
	gchar* _tmp22_;
	GtkApplication* _tmp23_;
	GtkApplication* _tmp24_;
	GNotification* _tmp25_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->priority_combobox;
	_tmp1_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case 3:
		{
			priority = G_NOTIFICATION_PRIORITY_URGENT;
			break;
		}
		case 2:
		{
			priority = G_NOTIFICATION_PRIORITY_HIGH;
			break;
		}
		case 0:
		{
			priority = G_NOTIFICATION_PRIORITY_LOW;
			break;
		}
		default:
		case 1:
		{
			priority = G_NOTIFICATION_PRIORITY_NORMAL;
			break;
		}
	}
	_tmp3_ = self->priv->title_entry;
	_tmp4_ = gtk_entry_get_text (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_notification_new (_tmp5_);
	notification = _tmp6_;
	_tmp7_ = notification;
	_tmp8_ = self->priv->body_entry;
	_tmp9_ = gtk_entry_get_text (_tmp8_);
	_tmp10_ = _tmp9_;
	g_notification_set_body (_tmp7_, _tmp10_);
	_tmp11_ = notification;
	_tmp12_ = priority;
	g_notification_set_priority (_tmp11_, _tmp12_);
	_tmp14_ = self->priv->id_entry;
	_tmp15_ = gtk_entry_get_text (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = strlen (_tmp16_);
	_tmp18_ = _tmp17_;
	if (_tmp18_ == 0) {
		_tmp13_ = NULL;
	} else {
		GtkEntry* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		_tmp19_ = self->priv->id_entry;
		_tmp20_ = gtk_entry_get_text (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp13_ = _tmp21_;
	}
	_tmp22_ = g_strdup (_tmp13_);
	id = _tmp22_;
	_tmp23_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp24_ = _tmp23_;
	_tmp25_ = notification;
	g_application_send_notification ((GApplication*) _tmp24_, id, _tmp25_);
	_g_free0 (id);
	_g_object_unref0 (notification);
}

static void
_main_window_send_notification_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
	main_window_send_notification ((MainWindow*) self);
}

static GObject *
main_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MainWindow * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkEntry* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkEntry* _tmp5_ = NULL;
	gchar* _tmp6_;
	GtkEntry* _tmp7_ = NULL;
	GtkLabel* priority_label = NULL;
	GtkLabel* _tmp8_;
	GtkComboBoxText* _tmp9_ = NULL;
	GtkComboBoxText* _tmp10_;
	GtkComboBoxText* _tmp11_;
	GtkComboBoxText* _tmp12_;
	GtkComboBoxText* _tmp13_;
	GtkComboBoxText* _tmp14_;
	GtkButton* send_button = NULL;
	GtkButton* _tmp15_ = NULL;
	GtkButton* _tmp16_;
	GtkStyleContext* _tmp17_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp18_ = NULL;
	GtkGrid* _tmp19_;
	GtkEntry* _tmp20_;
	GtkGrid* _tmp21_;
	GtkEntry* _tmp22_;
	GtkGrid* _tmp23_;
	GtkEntry* _tmp24_;
	GtkGrid* _tmp25_;
	GtkLabel* _tmp26_;
	GtkGrid* _tmp27_;
	GtkComboBoxText* _tmp28_;
	GtkGrid* _tmp29_;
	GtkButton* _tmp30_;
	GtkGrid* _tmp31_;
	GtkButton* _tmp32_;
	GtkButton* _tmp33_;
	parent_class = G_OBJECT_CLASS (main_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
	gtk_window_set_title ((GtkWindow*) self, "Notifications Demo");
	g_object_set ((GtkWindow*) self, "default-width", 400, NULL);
	_tmp0_ = g_strdup ("Title");
	_tmp1_ = g_strdup ("Title");
	_tmp2_ = (GtkEntry*) gtk_entry_new ();
	gtk_entry_set_activates_default (_tmp2_, TRUE);
	gtk_entry_set_placeholder_text (_tmp2_, _tmp0_);
	_g_free0 (_tmp0_);
	gtk_entry_set_text (_tmp2_, _tmp1_);
	_g_free0 (_tmp1_);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->title_entry);
	self->priv->title_entry = _tmp2_;
	_tmp3_ = g_strdup ("Body");
	_tmp4_ = g_strdup ("Body");
	_tmp5_ = (GtkEntry*) gtk_entry_new ();
	gtk_entry_set_activates_default (_tmp5_, TRUE);
	gtk_entry_set_placeholder_text (_tmp5_, _tmp3_);
	_g_free0 (_tmp3_);
	gtk_entry_set_text (_tmp5_, _tmp4_);
	_g_free0 (_tmp4_);
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->body_entry);
	self->priv->body_entry = _tmp5_;
	_tmp6_ = g_strdup ("Replaces Id");
	_tmp7_ = (GtkEntry*) gtk_entry_new ();
	gtk_entry_set_activates_default (_tmp7_, TRUE);
	gtk_entry_set_placeholder_text (_tmp7_, _tmp6_);
	_g_free0 (_tmp6_);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->id_entry);
	self->priv->id_entry = _tmp7_;
	_tmp8_ = (GtkLabel*) gtk_label_new ("Priority:");
	g_object_ref_sink (_tmp8_);
	priority_label = _tmp8_;
	_tmp9_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp9_, TRUE);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->priority_combobox);
	self->priv->priority_combobox = _tmp9_;
	_tmp10_ = self->priv->priority_combobox;
	gtk_combo_box_text_append_text (_tmp10_, "Low");
	_tmp11_ = self->priv->priority_combobox;
	gtk_combo_box_text_append_text (_tmp11_, "Normal");
	_tmp12_ = self->priv->priority_combobox;
	gtk_combo_box_text_append_text (_tmp12_, "High");
	_tmp13_ = self->priv->priority_combobox;
	gtk_combo_box_text_append_text (_tmp13_, "Urgent");
	_tmp14_ = self->priv->priority_combobox;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp14_, 1);
	_tmp15_ = (GtkButton*) gtk_button_new_with_label ("Send Notification");
	gtk_widget_set_can_default ((GtkWidget*) _tmp15_, TRUE);
	gtk_widget_set_halign ((GtkWidget*) _tmp15_, GTK_ALIGN_END);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp15_, 12);
	g_object_ref_sink (_tmp15_);
	send_button = _tmp15_;
	_tmp16_ = send_button;
	_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) _tmp16_);
	gtk_style_context_add_class (_tmp17_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp18_ = (GtkGrid*) gtk_grid_new ();
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
	gtk_grid_set_column_spacing (_tmp18_, 12);
	gtk_grid_set_row_spacing (_tmp18_, 12);
	g_object_set ((GtkWidget*) _tmp18_, "margin", 12, NULL);
	g_object_ref_sink (_tmp18_);
	grid = _tmp18_;
	_tmp19_ = grid;
	_tmp20_ = self->priv->title_entry;
	gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp20_, 0, 0, 2, 1);
	_tmp21_ = grid;
	_tmp22_ = self->priv->body_entry;
	gtk_grid_attach (_tmp21_, (GtkWidget*) _tmp22_, 0, 1, 2, 1);
	_tmp23_ = grid;
	_tmp24_ = self->priv->id_entry;
	gtk_grid_attach (_tmp23_, (GtkWidget*) _tmp24_, 0, 2, 2, 1);
	_tmp25_ = grid;
	_tmp26_ = priority_label;
	gtk_grid_attach (_tmp25_, (GtkWidget*) _tmp26_, 0, 3, 1, 1);
	_tmp27_ = grid;
	_tmp28_ = self->priv->priority_combobox;
	gtk_grid_attach (_tmp27_, (GtkWidget*) _tmp28_, 1, 3, 1, 1);
	_tmp29_ = grid;
	_tmp30_ = send_button;
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 0, 4, 2, 1);
	_tmp31_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp31_);
	_tmp32_ = send_button;
	g_object_set ((GtkWidget*) _tmp32_, "has-default", TRUE, NULL);
	_tmp33_ = send_button;
	g_signal_connect_object (_tmp33_, "clicked", (GCallback) _main_window_send_notification_gtk_button_clicked, self, 0);
	_g_object_unref0 (grid);
	_g_object_unref0 (send_button);
	_g_object_unref0 (priority_label);
	return obj;
}

static void
main_window_class_init (MainWindowClass * klass,
                        gpointer klass_data)
{
	main_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MainWindow_private_offset);
	G_OBJECT_CLASS (klass)->constructor = main_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = main_window_finalize;
}

static void
main_window_instance_init (MainWindow * self,
                           gpointer klass)
{
	self->priv = main_window_get_instance_private (self);
}

static void
main_window_finalize (GObject * obj)
{
	MainWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
	_g_object_unref0 (self->priv->title_entry);
	_g_object_unref0 (self->priv->body_entry);
	_g_object_unref0 (self->priv->id_entry);
	_g_object_unref0 (self->priv->priority_combobox);
	G_OBJECT_CLASS (main_window_parent_class)->finalize (obj);
}

static GType
main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MainWindow), 0, (GInstanceInitFunc) main_window_instance_init, NULL };
	GType main_window_type_id;
	main_window_type_id = g_type_register_static (gtk_application_window_get_type (), "MainWindow", &g_define_type_info, 0);
	MainWindow_private_offset = g_type_add_instance_private (main_window_type_id, sizeof (MainWindowPrivate));
	return main_window_type_id;
}

GType
main_window_get_type (void)
{
	static volatile gsize main_window_type_id__volatile = 0;
	if (g_once_init_enter (&main_window_type_id__volatile)) {
		GType main_window_type_id;
		main_window_type_id = main_window_get_type_once ();
		g_once_init_leave (&main_window_type_id__volatile, main_window_type_id);
	}
	return main_window_type_id__volatile;
}

